// bumpmapping.vert
#version 120

uniform vec3 tangent;

varying vec3 lightVector;
varying vec3 camera;

void main()
{
	vec3 position = (gl_ModelViewMatrix * gl_Vertex).xyz;
	
	// Tangent space
	vec3 N = gl_NormalMatrix * gl_Normal;
	vec3 T = gl_NormalMatrix * tangent;
	vec3 B = cross(N, T);

	mat3 TBN = transpose(mat3(T, B, N));
	
	// Light vector in tangent space
	vec3 temp = gl_LightSource[0].position.xyz - position;
	lightVector  = TBN * temp;

	// Camera vector in tangent space
	camera = TBN * (-position);

	gl_Position    = gl_ModelViewProjectionMatrix * gl_Vertex;
	gl_TexCoord[0] = gl_MultiTexCoord0;
}
