varying vec3 lightVector;
varying vec3 normal;
varying vec3 camera;

void main()
{
	vec4 ambient = vec4(0.0);
	vec4 diffuse = vec4(0.0);
	vec4 specular = vec4(0.0);

	float dist = length(lightVector);
	
	vec3 L = normalize(lightVector);
	vec3 N = normalize(normal);
	vec3 C = normalize(camera);

	float diffuseFactor = max(0.0, dot(N, L));
	float specularFactor = 0.0;

	if(diffuseFactor != 0.0) {
		vec3 halfVector = normalize(C + L);
		specularFactor = pow(dot(halfVector, N), gl_FrontMaterial.shininess);
	}	
	
	ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient;
	diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse * diffuseFactor;
	specular = gl_FrontMaterial.specular * gl_LightSource[0].specular * specularFactor;
	
	gl_FragColor = ambient + diffuse + specular;
					
	
}
